require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_BITOPS_H)) {
    eval 'sub _PARISC_BITOPS_H () {1;}' unless defined(&_PARISC_BITOPS_H);
    require 'linux/compiler.ph';
    require 'asm/system.ph';
    require 'asm/byteorder.ph';
    require 'asm/atomic.ph';
    if(defined(&__LP64__)) {
	eval 'sub SHIFT_PER_LONG () {6;}' unless defined(&SHIFT_PER_LONG);
	unless(defined(&BITS_PER_LONG)) {
	    eval 'sub BITS_PER_LONG () {64;}' unless defined(&BITS_PER_LONG);
	}
    } else {
	eval 'sub SHIFT_PER_LONG () {5;}' unless defined(&SHIFT_PER_LONG);
	unless(defined(&BITS_PER_LONG)) {
	    eval 'sub BITS_PER_LONG () {32;}' unless defined(&BITS_PER_LONG);
	}
    }
    eval 'sub CHOP_SHIFTCOUNT {
        my($x) = @_;
	    eval q((($x) & ( &BITS_PER_LONG - 1)));
    }' unless defined(&CHOP_SHIFTCOUNT);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__after_clear_bit);
    eval 'sub set_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; my $flags;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &_atomic_spin_lock_irqsave( &addr,  $flags); * &addr |=  $mask;  &_atomic_spin_unlock_irqrestore( &addr,  $flags); });
    }' unless defined(&set_bit);
    eval 'sub __set_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); * &addr |=  $mask; });
    }' unless defined(&__set_bit);
    eval 'sub clear_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; my $flags;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &_atomic_spin_lock_irqsave( &addr,  $flags); * &addr &= ~ $mask;  &_atomic_spin_unlock_irqrestore( &addr,  $flags); });
    }' unless defined(&clear_bit);
    eval 'sub __clear_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); * &addr &= ~ $mask; });
    }' unless defined(&__clear_bit);
    eval 'sub change_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; my $flags;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &_atomic_spin_lock_irqsave( &addr,  $flags); * &addr ^=  $mask;  &_atomic_spin_unlock_irqrestore( &addr,  $flags); });
    }' unless defined(&change_bit);
    eval 'sub __change_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); * &addr ^=  $mask; });
    }' unless defined(&__change_bit);
    eval 'sub test_and_set_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; \'int\'  &oldbit; my $flags;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &_atomic_spin_lock_irqsave( &addr,  $flags);  &oldbit = (* &addr &  $mask) ? 1: 0; * &addr |=  $mask;  &_atomic_spin_unlock_irqrestore( &addr,  $flags);  &oldbit; });
    }' unless defined(&test_and_set_bit);
    eval 'sub __test_and_set_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; \'int\'  &oldbit;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &oldbit = (* &addr &  $mask) ? 1: 0; * &addr |=  $mask;  &oldbit; });
    }' unless defined(&__test_and_set_bit);
    eval 'sub test_and_clear_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; \'int\'  &oldbit; my $flags;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &_atomic_spin_lock_irqsave( &addr,  $flags);  &oldbit = (* &addr &  $mask) ? 1: 0; * &addr &= ~ $mask;  &_atomic_spin_unlock_irqrestore( &addr,  $flags);  &oldbit; });
    }' unless defined(&test_and_clear_bit);
    eval 'sub __test_and_clear_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; \'int\'  &oldbit;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &oldbit = (* &addr &  $mask) ? 1: 0; * &addr &= ~ $mask;  &oldbit; });
    }' unless defined(&__test_and_clear_bit);
    eval 'sub test_and_change_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; \'int\'  &oldbit; my $flags;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &_atomic_spin_lock_irqsave( &addr,  $flags);  &oldbit = (* &addr &  $mask) ? 1: 0; * &addr ^=  $mask;  &_atomic_spin_unlock_irqrestore( &addr,  $flags);  &oldbit; });
    }' unless defined(&test_and_change_bit);
    eval 'sub __test_and_change_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask; \'unsigned long\' * &addr =  $address; \'int\'  &oldbit;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr);  &oldbit = (* &addr &  $mask) ? 1: 0; * &addr ^=  $mask;  &oldbit; });
    }' unless defined(&__test_and_change_bit);
    eval 'sub test_bit {
        my($nr,$address) = @_;
	    eval q({ my $mask;  &const \'unsigned long\' * &addr = ( &const \'unsigned long\' *)$address;  &addr += ($nr >>  &SHIFT_PER_LONG);  $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); !!(* &addr &  $mask); });
    }' unless defined(&test_bit);
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) > 32) {
    } else {
    }
    eval 'sub ffz {
        my($x) = @_;
	    eval q( &__ffs(~$x));
    }' unless defined(&ffz);
    unless(defined(&_STRING_H)) {
	eval 'sub ffs {
	    my($x) = @_;
    	    eval q({ $x ? ( &__ffs($x) + 1) : 0; });
	}' unless defined(&ffs);
    }
    eval 'sub hweight64 {
        my($x) = @_;
	    eval q(({ \'unsigned long __x\' = ($x); \'unsigned int __w\';  &__w =  &generic_hweight32(  &__x);  &__w +=  &generic_hweight32( ( &__x>>32));  &__w; }));
    }' unless defined(&hweight64);
    eval 'sub hweight32 {
        my($x) = @_;
	    eval q( &generic_hweight32($x));
    }' unless defined(&hweight32);
    eval 'sub hweight16 {
        my($x) = @_;
	    eval q( &generic_hweight16($x));
    }' unless defined(&hweight16);
    eval 'sub hweight8 {
        my($x) = @_;
	    eval q( &generic_hweight8($x));
    }' unless defined(&hweight8);
    unless(defined(&__LP64__)) {
    } else {
    }
    eval 'sub find_first_zero_bit {
        my($addr, $size) = @_;
	    eval q( &find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_bit);
    eval 'sub find_next_zero_bit {
        my($addr,$size,$offset) = @_;
	    eval q({  &const \'unsigned long\' *  &p = ( $addr) + ($offset >>  &SHIFT_PER_LONG); my $result = $offset & ~( &BITS_PER_LONG-1); my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= ( &BITS_PER_LONG-1);  &if ($offset) {  $tmp = *( &p++);  $tmp |= ~0 >> ( &BITS_PER_LONG-$offset);  &if ($size <  &BITS_PER_LONG)  &goto  &found_first;  &if (~ $tmp)  &goto  &found_middle; $size -=  &BITS_PER_LONG;  $result +=  &BITS_PER_LONG; }  &while ($size & ~( &BITS_PER_LONG -1)) {  &if (~( $tmp = *( &p++)))  &goto  &found_middle;  $result +=  &BITS_PER_LONG; $size -=  &BITS_PER_LONG; }  &if (!$size)  $result;  $tmp = * &p;  &found_first:  $tmp |= ~0 << $size;  &found_middle:  $result +  &ffz( $tmp); });
    }' unless defined(&find_next_zero_bit);
    eval 'sub find_next_bit {
        my($addr,$size,$offset) = @_;
	    eval q({  &const \'unsigned long\' * &p = $addr + ($offset >> 6); my $result = $offset & ~( &BITS_PER_LONG-1); my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= ( &BITS_PER_LONG-1);  &if ($offset) {  $tmp = *( &p++);  $tmp &= (~0 << $offset);  &if ($size <  &BITS_PER_LONG)  &goto  &found_first;  &if ( $tmp)  &goto  &found_middle; $size -=  &BITS_PER_LONG;  $result +=  &BITS_PER_LONG; }  &while ($size & ~( &BITS_PER_LONG-1)) {  &if (( $tmp = *( &p++)))  &goto  &found_middle;  $result +=  &BITS_PER_LONG; $size -=  &BITS_PER_LONG; }  &if (!$size)  $result;  $tmp = * &p;  &found_first:  $tmp &= (~0 >> ( &BITS_PER_LONG - $size));  &if ( $tmp == 0)  $result + $size;  &found_middle:  $result +  &__ffs( $tmp); });
    }' unless defined(&find_next_bit);
    eval 'sub find_first_bit {
        my($addr, $size) = @_;
	    eval q( &find_next_bit(($addr), ($size), 0));
    }' unless defined(&find_first_bit);
    eval 'sub _EXT2_HAVE_ASM_BITOPS_ () {1;}' unless defined(&_EXT2_HAVE_ASM_BITOPS_);
    if(defined(&__KERNEL__)) {
	if(defined(&__LP64__)) {
	    eval 'sub ext2_set_bit {
	        my($nr, $addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_set_bit);
	    eval 'sub ext2_set_bit_atomic {
	        my($l,$nr,$addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_set_bit_atomic);
	    eval 'sub ext2_clear_bit {
	        my($nr, $addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_clear_bit);
	    eval 'sub ext2_clear_bit_atomic {
	        my($l,$nr,$addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_clear_bit_atomic);
	} else {
	    eval 'sub ext2_set_bit {
	        my($nr, $addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_set_bit);
	    eval 'sub ext2_set_bit_atomic {
	        my($l,$nr,$addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_set_bit_atomic);
	    eval 'sub ext2_clear_bit {
	        my($nr, $addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_clear_bit);
	    eval 'sub ext2_clear_bit_atomic {
	        my($l,$nr,$addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_clear_bit_atomic);
	}
    }
    eval 'sub ext2_test_bit {
        my($nr,$addr) = @_;
	    eval q({  &__const__ \'unsigned char\' * &ADDR = ( &__const__ \'unsigned char\' *) $addr; ( $ADDR[$nr >> 3] >> ($nr & 7)) & 1; });
    }' unless defined(&ext2_test_bit);
    eval 'sub ext2_find_first_zero_bit {
        my($addr, $size) = @_;
	    eval q( &ext2_find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&ext2_find_first_zero_bit);
    eval 'sub ext2_find_next_zero_bit {
        my($addr,$size,$offset) = @_;
	    eval q({ \'unsigned int\' * &p = ( $addr) + ($offset >> 5); my $result = $offset & ~31; my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= 31;  &if ($offset) {  $tmp =  &__cpu_to_le32p( &p++);  $tmp |= ~0 >> (32-$offset);  &if ($size < 32)  &goto  &found_first;  &if ( $tmp != ~0)  &goto  &found_middle; $size -= 32;  $result += 32; }  &while ($size >= 32) {  &if (( $tmp =  &__cpu_to_le32p( &p++)) != ~0)  &goto  &found_middle;  $result += 32; $size -= 32; }  &if (!$size)  $result;  $tmp =  &__cpu_to_le32p( &p);  &found_first:  $tmp |= ~0 << $size;  &found_middle:  $result +  &ffz( $tmp); });
    }' unless defined(&ext2_find_next_zero_bit);
    eval 'sub minix_test_and_set_bit {
        my($nr,$addr) = @_;
	    eval q( &ext2_set_bit($nr,$addr));
    }' unless defined(&minix_test_and_set_bit);
    eval 'sub minix_set_bit {
        my($nr,$addr) = @_;
	    eval q((( &void) &ext2_set_bit($nr,$addr)));
    }' unless defined(&minix_set_bit);
    eval 'sub minix_test_and_clear_bit {
        my($nr,$addr) = @_;
	    eval q( &ext2_clear_bit($nr,$addr));
    }' unless defined(&minix_test_and_clear_bit);
    eval 'sub minix_test_bit {
        my($nr,$addr) = @_;
	    eval q( &ext2_test_bit($nr,$addr));
    }' unless defined(&minix_test_bit);
    eval 'sub minix_find_first_zero_bit {
        my($addr,$size) = @_;
	    eval q( &ext2_find_first_zero_bit($addr,$size));
    }' unless defined(&minix_find_first_zero_bit);
}
1;
