require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_CACHEFLUSH_H)) {
    eval 'sub _PARISC_CACHEFLUSH_H () {1;}' unless defined(&_PARISC_CACHEFLUSH_H);
    require 'linux/config.ph';
    require 'linux/mm.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub flush_cache_mm {
	    my($mm) = @_;
    	    eval q( &flush_cache_all());
	}' unless defined(&flush_cache_mm);
    } else {
	eval 'sub flush_cache_mm {
	    my($mm) = @_;
    	    eval q( &flush_cache_all_local());
	}' unless defined(&flush_cache_mm);
    }
    eval 'sub flush_kernel_dcache_range {
        my($start,$size) = @_;
	    eval q( &flush_kernel_dcache_range_asm(($start), ($start)+($size)););
    }' unless defined(&flush_kernel_dcache_range);
    eval 'sub cacheflush_h_tmp_function {
        my($dummy) = @_;
	    eval q({  &flush_cache_all_local(); });
    }' unless defined(&cacheflush_h_tmp_function);
    eval 'sub flush_cache_all {
        my($void) = @_;
	    eval q({  &on_each_cpu( &cacheflush_h_tmp_function,  &NULL, 1, 1); });
    }' unless defined(&flush_cache_all);
    eval 'sub flush_cache_vmap {
        my($start, $end) = @_;
	    eval q( &flush_cache_all());
    }' unless defined(&flush_cache_vmap);
    eval 'sub flush_cache_vunmap {
        my($start, $end) = @_;
	    eval q( &flush_cache_all());
    }' unless defined(&flush_cache_vunmap);
    eval 'sub flush_user_dcache_range {
        my($start,$end) = @_;
	    eval q({  &if (($end - $start) <  &parisc_cache_flush_threshold)  &flush_user_dcache_range_asm($start,$end);  &else  &flush_data_cache(); });
    }' unless defined(&flush_user_dcache_range);
    eval 'sub flush_user_icache_range {
        my($start,$end) = @_;
	    eval q({  &if (($end - $start) <  &parisc_cache_flush_threshold)  &flush_user_icache_range_asm($start,$end);  &else  &flush_instruction_cache(); });
    }' unless defined(&flush_user_icache_range);
    eval 'sub flush_dcache_mmap_lock {
        my($mapping) = @_;
	    eval q( &spin_lock_irq(($mapping)-> &tree_lock));
    }' unless defined(&flush_dcache_mmap_lock);
    eval 'sub flush_dcache_mmap_unlock {
        my($mapping) = @_;
	    eval q( &spin_unlock_irq(($mapping)-> &tree_lock));
    }' unless defined(&flush_dcache_mmap_unlock);
    eval 'sub flush_icache_page {
        my($vma,$page) = @_;
	    eval q( &do {  &flush_kernel_dcache_page( &page_address($page));  &flush_kernel_icache_page( &page_address($page)); }  &while (0));
    }' unless defined(&flush_icache_page);
    eval 'sub flush_icache_range {
        my($s,$e) = @_;
	    eval q( &do {  &flush_kernel_dcache_range_asm($s,$e);  &flush_kernel_icache_range_asm($s,$e); }  &while (0));
    }' unless defined(&flush_icache_range);
    eval 'sub copy_to_user_page {
        my($vma, $page, $vaddr, $dst, $src, $len) = @_;
	    eval q( &do {  &flush_cache_page($vma, $vaddr);  &memcpy($dst, $src, $len);  &flush_kernel_dcache_range_asm($dst, $dst + $len); }  &while (0));
    }' unless defined(&copy_to_user_page);
    eval 'sub copy_from_user_page {
        my($vma, $page, $vaddr, $dst, $src, $len) = @_;
	    eval q( &do {  &flush_cache_page($vma, $vaddr);  &memcpy($dst, $src, $len); }  &while (0));
    }' unless defined(&copy_from_user_page);
    eval 'sub flush_cache_range {
        my($vma,$start,$end) = @_;
	    eval q({ \'int\'  &sr3;  &if (! ($vma->{vm_mm}->{context})) {  &BUG(); ; }  &sr3 =  &mfsp(3);  &if ( ($vma->{vm_mm}->{context}) ==  &sr3) {  &flush_user_dcache_range($start,$end);  &flush_user_icache_range($start,$end); }  &else {  &flush_cache_all(); } });
    }' unless defined(&flush_cache_range);
    eval 'sub translation_exists {
        my($vma, $addr) = @_;
	    eval q( &__translation_exists(($vma)-> &vm_mm, $addr));
    }' unless defined(&translation_exists);
    eval 'sub __flush_cache_page {
        my($vma,$vmaddr) = @_;
	    eval q({  &if ( &likely( ($vma->{vm_mm}->{context}) ==  &mfsp(3))) {  &flush_user_dcache_page($vmaddr);  &if ( ($vma->{vm_flags}) &  &VM_EXEC)  &flush_user_icache_page($vmaddr); }  &else {  &flush_user_cache_page_non_current($vma, $vmaddr); } });
    }' unless defined(&__flush_cache_page);
    eval 'sub flush_cache_page {
        my($vma,$vmaddr) = @_;
	    eval q({  &BUG_ON(! ($vma->{vm_mm}->{context}));  &if( &likely( &translation_exists($vma, $vmaddr)))  &__flush_cache_page($vma, $vmaddr); });
    }' unless defined(&flush_cache_page);
}
1;
