require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SPINLOCK_H)) {
    eval 'sub __ASM_SPINLOCK_H () {1;}' unless defined(&__ASM_SPINLOCK_H);
    require 'asm/system.ph';
    unless(defined(&CONFIG_DEBUG_SPINLOCK)) {
	eval 'sub __SPIN_LOCK_UNLOCKED () {{ { 1, 1, 1, 1} };}' unless defined(&__SPIN_LOCK_UNLOCKED);
	undef(&SPIN_LOCK_UNLOCKED) if defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t)  &__SPIN_LOCK_UNLOCKED;}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    my($x) = @_;
    	    eval q( &do { *($x) =  &SPIN_LOCK_UNLOCKED; }  &while(0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_is_locked {
	    my($x) = @_;
    	    eval q({  &volatile \'unsigned int\' * &a =  &__ldcw_align($x); * &a == 0; });
	}' unless defined(&spin_is_locked);
	eval 'sub spin_unlock_wait {
	    my($x) = @_;
    	    eval q( &do {  &barrier(); }  &while( &spin_is_locked($x)));
	}' unless defined(&spin_unlock_wait);
	eval 'sub _raw_spin_lock_flags {
	    my($lock, $flags) = @_;
    	    eval q( &_raw_spin_lock($lock));
	}' unless defined(&_raw_spin_lock_flags);
	eval 'sub _raw_spin_lock {
	    my($x) = @_;
    	    eval q({  &volatile \'unsigned int\' * &a;  &mb();  &a =  &__ldcw_align($x);  &while ( &__ldcw( &a) == 0)  &while (* &a == 0);  &mb(); });
	}' unless defined(&_raw_spin_lock);
	eval 'sub _raw_spin_unlock {
	    my($x) = @_;
    	    eval q({  &volatile \'unsigned int\' * &a;  &mb();  &a =  &__ldcw_align($x); * &a = 1;  &mb(); });
	}' unless defined(&_raw_spin_unlock);
	eval 'sub _raw_spin_trylock {
	    my($x) = @_;
    	    eval q({  &volatile \'unsigned int\' * &a; \'int\'  &ret;  &mb();  &a =  &__ldcw_align($x);  &ret =  &__ldcw( &a) != 0;  &mb();  &ret; });
	}' unless defined(&_raw_spin_trylock);
	eval 'sub spin_lock_own {
	    my($LOCK, $LOCATION) = @_;
    	    eval q((( &void)0));
	}' unless defined(&spin_lock_own);
    } else {
	eval 'sub SPINLOCK_MAGIC () {0x1d244b3c;}' unless defined(&SPINLOCK_MAGIC);
	eval 'sub __SPIN_LOCK_UNLOCKED () {{ { 1, 1, 1, 1},  &SPINLOCK_MAGIC, 10,  &__FILE__ ,  &NULL, 0, -1,  &NULL,  &NULL };}' unless defined(&__SPIN_LOCK_UNLOCKED);
	undef(&SPIN_LOCK_UNLOCKED) if defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t)  &__SPIN_LOCK_UNLOCKED;}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    my($x) = @_;
    	    eval q( &do { *($x) =  &SPIN_LOCK_UNLOCKED; }  &while(0));
	}' unless defined(&spin_lock_init);
	eval 'sub CHECK_LOCK {
	    my($x) = @_;
    	    eval q( &do {  &if ( &unlikely(($x)-> &magic !=  &SPINLOCK_MAGIC)) {  &printk( &KERN_ERR \\"%s:%d: spin_is_locked\\" \\" on uninitialized spinlock %p.\\\\n\\",  &__FILE__,  &__LINE__, ($x)); } }  &while(0));
	}' unless defined(&CHECK_LOCK);
	eval 'sub spin_is_locked {
	    my($x) = @_;
    	    eval q(({  &CHECK_LOCK($x);  &volatile \'unsigned int\' * &a =  &__ldcw_align($x);  &if ( &unlikely((* &a == 0)  && ($x)-> &babble)) { ($x)-> &babble--;  &printk(\\"KERN_WARNING								%s:%d: spin_is_locked(%s/%p) already\\" \\" locked by %s:%d in %s at %p(%d)\\\\n\\",  &__FILE__, &__LINE__, ($x)-> &module, ($x), ($x)-> &bfile, ($x)-> &bline, ($x)-> ($task->{comm}), ($x)-> &previous, ($x)-> &oncpu); } * &a == 0; }));
	}' unless defined(&spin_is_locked);
	eval 'sub spin_unlock_wait {
	    my($x) = @_;
    	    eval q( &do {  &CHECK_LOCK($x);  &volatile \'unsigned int\' * &a =  &__ldcw_align($x);  &if ( &unlikely((* &a == 0)  && ($x)-> &babble)) { ($x)-> &babble--;  &printk(\\"KERN_WARNING								%s:%d: spin_unlock_wait(%s/%p)\\" \\" owned by %s:%d in %s at %p(%d)\\\\n\\",  &__FILE__, &__LINE__, ($x)-> &module, ($x), ($x)-> &bfile, ($x)-> &bline, ($x)-> ($task->{comm}), ($x)-> &previous, ($x)-> &oncpu); }  &barrier(); }  &while (*(( &volatile \'unsigned char\' *)( &__ldcw_align($x))) == 0));
	}' unless defined(&spin_unlock_wait);
	eval 'sub _raw_spin_lock_flags {
	    my($lock, $flags) = @_;
    	    eval q( &_raw_spin_lock($lock));
	}' unless defined(&_raw_spin_lock_flags);
	eval 'sub _raw_spin_unlock {
	    my($lock) = @_;
    	    eval q( &_dbg_spin_unlock($lock,  &__FILE__,  &__LINE__));
	}' unless defined(&_raw_spin_unlock);
	eval 'sub _raw_spin_lock {
	    my($lock) = @_;
    	    eval q( &_dbg_spin_lock($lock,  &__FILE__,  &__LINE__));
	}' unless defined(&_raw_spin_lock);
	eval 'sub _raw_spin_trylock {
	    my($lock) = @_;
    	    eval q( &_dbg_spin_trylock($lock,  &__FILE__,  &__LINE__));
	}' unless defined(&_raw_spin_trylock);
	eval 'sub spin_lock_own {
	    my($LOCK, $LOCATION) = @_;
    	    eval q( &do {  &volatile \'unsigned int\' * &a =  &__ldcw_align($LOCK);  &if (!((* &a == 0)  && (($LOCK)-> &oncpu ==  &smp_processor_id())))  &printk(\\"KERN_WARNING								%s: called on %d from %p but lock %s on %d\\\\n\\", $LOCATION,  &smp_processor_id(),  &__builtin_return_address(0), (* &a == 0) ? \\"taken\\" : \\"freed\\", ($LOCK)-> &on_cpu); }  &while (0));
	}' unless defined(&spin_lock_own);
    }
    if(defined(&CONFIG_PREEMPT)) {
    }
    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) {  &__SPIN_LOCK_UNLOCKED, 0};}' unless defined(&RW_LOCK_UNLOCKED);
    eval 'sub rwlock_init {
        my($lp) = @_;
	    eval q( &do { *($lp) =  &RW_LOCK_UNLOCKED; }  &while (0));
    }' unless defined(&rwlock_init);
    eval 'sub _raw_read_trylock {
        my($lock) = @_;
	    eval q( &generic_raw_read_trylock($lock));
    }' unless defined(&_raw_read_trylock);
    if(defined(&CONFIG_DEBUG_RWLOCK)) {
	eval 'sub _raw_read_lock {
	    my($rw) = @_;
    	    eval q( &_dbg_read_lock($rw,  &__FILE__,  &__LINE__));
	}' unless defined(&_raw_read_lock);
    } else {
	eval 'sub _raw_read_lock {
	    my($rw) = @_;
    	    eval q({ my $flags;  &local_irq_save( $flags);  &_raw_spin_lock( ($rw->{lock}));  ($rw->{counter})++;  &_raw_spin_unlock( ($rw->{lock}));  &local_irq_restore( $flags); });
	}' unless defined(&_raw_read_lock);
    }
    eval 'sub _raw_read_unlock {
        my($rw) = @_;
	    eval q({ my $flags;  &local_irq_save( $flags);  &_raw_spin_lock( ($rw->{lock}));  ($rw->{counter})--;  &_raw_spin_unlock( ($rw->{lock}));  &local_irq_restore( $flags); });
    }' unless defined(&_raw_read_unlock);
    if(defined(&CONFIG_DEBUG_RWLOCK)) {
	eval 'sub _raw_write_lock {
	    my($rw) = @_;
    	    eval q( &_dbg_write_lock($rw,  &__FILE__,  &__LINE__));
	}' unless defined(&_raw_write_lock);
    } else {
	eval 'sub _raw_write_lock {
	    my($rw) = @_;
    	    eval q({  &retry:  &_raw_spin_lock( ($rw->{lock}));  &if( ($rw->{counter}) != 0) {  &_raw_spin_unlock( ($rw->{lock}));  &while( ($rw->{counter}) != 0);  &goto  &retry; }  ($rw->{counter}) = -1; });
	}' unless defined(&_raw_write_lock);
    }
    if(defined(&CONFIG_DEBUG_RWLOCK)) {
	eval 'sub _raw_write_trylock {
	    my($rw) = @_;
    	    eval q( &_dbg_write_trylock($rw,  &__FILE__,  &__LINE__));
	}' unless defined(&_raw_write_trylock);
    } else {
	eval 'sub _raw_write_trylock {
	    my($rw) = @_;
    	    eval q({  &_raw_spin_lock( ($rw->{lock}));  &if ( ($rw->{counter}) != 0) {  &_raw_spin_unlock( ($rw->{lock})); 0; }  ($rw->{counter}) = -1; 1; });
	}' unless defined(&_raw_write_trylock);
    }
    eval 'sub is_read_locked {
        my($rw) = @_;
	    eval q({  ($rw->{counter}) > 0; });
    }' unless defined(&is_read_locked);
    eval 'sub is_write_locked {
        my($rw) = @_;
	    eval q({  ($rw->{counter}) < 0; });
    }' unless defined(&is_write_locked);
}
1;
