require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PARISC_UACCESS_H)) {
    eval 'sub __PARISC_UACCESS_H () {1;}' unless defined(&__PARISC_UACCESS_H);
    require 'linux/sched.ph';
    require 'asm/page.ph';
    require 'asm/system.ph';
    require 'asm/cache.ph';
    require 'asm-generic/uaccess.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub KERNEL_DS () {(( &mm_segment_t){0});}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () {(( &mm_segment_t){1});}' unless defined(&USER_DS);
    eval 'sub segment_eq {
        my($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( &current_thread_info()-> &addr_limit));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        my($x) = @_;
	    eval q(( &current_thread_info()-> &addr_limit = ($x)));
    }' unless defined(&set_fs);
    eval 'sub access_ok {
        my($type,$addr,$size) = @_;
	    eval q((1));
    }' unless defined(&access_ok);
    eval 'sub verify_area {
        my($type,$addr,$size) = @_;
	    eval q((0));
    }' unless defined(&verify_area);
    eval 'sub put_user () { &__put_user;}' unless defined(&put_user);
    eval 'sub get_user () { &__get_user;}' unless defined(&get_user);
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) == 32) {
	eval 'sub LDD_KERNEL {
	    my($ptr) = @_;
    	    eval q( &__get_kernel_bad(););
	}' unless defined(&LDD_KERNEL);
	eval 'sub LDD_USER {
	    my($ptr) = @_;
    	    eval q( &__get_user_bad(););
	}' unless defined(&LDD_USER);
	eval 'sub STD_KERNEL {
	    my($x, $ptr) = @_;
    	    eval q( &__put_kernel_asm64($x,$ptr));
	}' unless defined(&STD_KERNEL);
	eval 'sub STD_USER {
	    my($x, $ptr) = @_;
    	    eval q( &__put_user_asm64($x,$ptr));
	}' unless defined(&STD_USER);
    } else {
	eval 'sub LDD_KERNEL {
	    my($ptr) = @_;
    	    eval q( &__get_kernel_asm(\\"ldd\\",$ptr));
	}' unless defined(&LDD_KERNEL);
	eval 'sub LDD_USER {
	    my($ptr) = @_;
    	    eval q( &__get_user_asm(\\"ldd\\",$ptr));
	}' unless defined(&LDD_USER);
	eval 'sub STD_KERNEL {
	    my($x, $ptr) = @_;
    	    eval q( &__put_kernel_asm(\\"std\\",$x,$ptr));
	}' unless defined(&STD_KERNEL);
	eval 'sub STD_USER {
	    my($x, $ptr) = @_;
    	    eval q( &__put_user_asm(\\"std\\",$x,$ptr));
	}' unless defined(&STD_USER);
    }
    eval 'sub __get_user {
        my($x,$ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user);
    if(defined(&__LP64__)) {
	eval 'sub __get_kernel_asm {
	    my($ldx,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_kernel_asm);
	eval 'sub __get_user_asm {
	    my($ldx,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_user_asm);
    } else {
	eval 'sub __get_kernel_asm {
	    my($ldx,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_kernel_asm);
	eval 'sub __get_user_asm {
	    my($ldx,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_user_asm);
    }
    eval 'sub __put_user {
        my($x,$ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user);
    if(defined(&__LP64__)) {
	eval 'sub __put_kernel_asm {
	    my($stx,$x,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_kernel_asm);
	eval 'sub __put_user_asm {
	    my($stx,$x,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_user_asm);
    } else {
	eval 'sub __put_kernel_asm {
	    my($stx,$x,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_kernel_asm);
	eval 'sub __put_user_asm {
	    my($stx,$x,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_user_asm);
	eval 'sub __put_kernel_asm64 {
	    my($__val,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_kernel_asm64);
	eval 'sub __put_user_asm64 {
	    my($__val,$ptr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_user_asm64);
    }
    eval 'sub strncpy_from_user () { &lstrncpy_from_user;}' unless defined(&strncpy_from_user);
    eval 'sub strnlen_user () { &lstrnlen_user;}' unless defined(&strnlen_user);
    eval 'sub strlen_user {
        my($str) = @_;
	    eval q( &lstrnlen_user($str, 0x7fffffff));
    }' unless defined(&strlen_user);
    eval 'sub clear_user () { &lclear_user;}' unless defined(&clear_user);
    eval 'sub __clear_user () { &lclear_user;}' unless defined(&__clear_user);
    eval 'sub __copy_to_user () { &copy_to_user;}' unless defined(&__copy_to_user);
    eval 'sub __copy_from_user () { &copy_from_user;}' unless defined(&__copy_from_user);
    eval 'sub __copy_in_user () { &copy_in_user;}' unless defined(&__copy_in_user);
    eval 'sub __copy_to_user_inatomic () { &__copy_to_user;}' unless defined(&__copy_to_user_inatomic);
    eval 'sub __copy_from_user_inatomic () { &__copy_from_user;}' unless defined(&__copy_from_user_inatomic);
}
1;
