require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MMAN_H)) {
    die("Never use <bits/mman.h> directly; include <sys/mman.h> instead.");
}
unless(defined(&PROT_READ)) {
    sub PROT_READ () {	0x1;}
}
unless(defined(&PROT_WRITE)) {
    sub PROT_WRITE () {	0x2;}
}
unless(defined(&PROT_EXEC)) {
    sub PROT_EXEC () {	0x4;}
}
unless(defined(&PROT_NONE)) {
    sub PROT_NONE () {	0x;}
}
unless(defined(&PROT_GROWSDOWN)) {
    sub PROT_GROWSDOWN () {	0x1000000;}
}
unless(defined(&PROT_GROWSUP)) {
    sub PROT_GROWSUP () {	0x2000000;}
}
unless(defined(&MAP_SHARED)) {
    sub MAP_SHARED () {	0x1;}
}
unless(defined(&MAP_PRIVATE)) {
    sub MAP_PRIVATE () {	0x2;}
}
unless(defined(&MAP_TYPE)) {
    sub MAP_TYPE () {	0x3;}
}
unless(defined(&MAP_FIXED)) {
    sub MAP_FIXED () {	0x4;}
}
unless(defined(&MAP_ANONYMOUS)) {
    sub MAP_ANONYMOUS () {	0x10;}
}
unless(defined(&MAP_DENYWRITE)) {
    sub MAP_DENYWRITE () {	0x800;}
}
unless(defined(&MAP_EXECUTABLE)) {
    sub MAP_EXECUTABLE () {	0x1000;}
}
unless(defined(&MAP_LOCKED)) {
    sub MAP_LOCKED () {	0x2000;}
}
unless(defined(&MAP_NORESERVE)) {
    sub MAP_NORESERVE () {	0x4000;}
}
unless(defined(&MAP_GROWSDOWN)) {
    sub MAP_GROWSDOWN () {	0x8000;}
}
unless(defined(&MAP_POPULATE)) {
    sub MAP_POPULATE () {	0x10000;}
}
unless(defined(&MAP_NONBLOCK)) {
    sub MAP_NONBLOCK () {	0x20000;}
}
unless(defined(&MS_SYNC)) {
    sub MS_SYNC () {	1;}
}
unless(defined(&MS_ASYNC)) {
    sub MS_ASYNC () {	2;}
}
unless(defined(&MS_INVALIDATE)) {
    sub MS_INVALIDATE () {	4;}
}
unless(defined(&MCL_CURRENT)) {
    sub MCL_CURRENT () {	1;}
}
unless(defined(&MCL_FUTURE)) {
    sub MCL_FUTURE () {	2;}
}
unless(defined(&MADV_NORMAL)) {
    sub MADV_NORMAL () {	0;}
}
unless(defined(&MADV_RANDOM)) {
    sub MADV_RANDOM () {	1;}
}
unless(defined(&MADV_SEQUENTIAL)) {
    sub MADV_SEQUENTIAL () {	2;}
}
unless(defined(&MADV_WILLNEED)) {
    sub MADV_WILLNEED () {	3;}
}
unless(defined(&MADV_DONTNEED)) {
    sub MADV_DONTNEED () {	4;}
}
unless(defined(&MADV_SPACEAVAIL)) {
    sub MADV_SPACEAVAIL () {	5;}
}
unless(defined(&MADV_VPS_PURGE)) {
    sub MADV_VPS_PURGE () {	6;}
}
unless(defined(&MADV_VPS_INHERIT)) {
    sub MADV_VPS_INHERIT () {	7;}
}
unless(defined(&MADV_4K_PAGES)) {
    sub MADV_4K_PAGES () {	12;}
}
unless(defined(&MADV_16K_PAGES)) {
    sub MADV_16K_PAGES () {	14;}
}
unless(defined(&MADV_64K_PAGES)) {
    sub MADV_64K_PAGES () {	16;}
}
unless(defined(&MADV_256K_PAGES)) {
    sub MADV_256K_PAGES () {	18;}
}
unless(defined(&MADV_1M_PAGES)) {
    sub MADV_1M_PAGES () {	20;}
}
unless(defined(&MADV_4M_PAGES)) {
    sub MADV_4M_PAGES () {	22;}
}
unless(defined(&MADV_16M_PAGES)) {
    sub MADV_16M_PAGES () {	24;}
}
unless(defined(&MADV_64M_PAGES)) {
    sub MADV_64M_PAGES () {	26;}
}
unless(defined(&MAP_ANON)) {
    sub MAP_ANON () {	 &MAP_ANONYMOUS;}
}
unless(defined(&MAP_FILE)) {
    sub MAP_FILE () {	0;}
}
unless(defined(&MAP_VARIABLE)) {
    sub MAP_VARIABLE () {	0;}
}
if(defined(&__USE_GNU)) {
    eval 'sub MREMAP_MAYMOVE () {1;}' unless defined(&MREMAP_MAYMOVE);
}
if(defined(&__USE_XOPEN2K)) {
    eval 'sub POSIX_MADV_NORMAL () {0;}' unless defined(&POSIX_MADV_NORMAL);
    eval 'sub POSIX_MADV_RANDOM () {1;}' unless defined(&POSIX_MADV_RANDOM);
    eval 'sub POSIX_MADV_SEQUENTIAL () {2;}' unless defined(&POSIX_MADV_SEQUENTIAL);
    eval 'sub POSIX_MADV_WILLNEED () {3;}' unless defined(&POSIX_MADV_WILLNEED);
    eval 'sub POSIX_MADV_DONTNEED () {4;}' unless defined(&POSIX_MADV_DONTNEED);
}
1;
